﻿Imports System.IO
Imports System.Text
Public Class MatrizGrid

    Private NLMat As Integer
    Private NCMat As Integer
    Private Matiz(,) As Single

    Public Property NLinhas() As Integer
        Get
            Return NLMat
        End Get
        Set(ByVal value As Integer)
            TextBoxNL.Text = value
            TextBoxNL_Validated(Nothing, Nothing)
            ReDim Matiz(NLMat + 1, NCMat + 1)
            Grid2Mat(Me.DataGridView1, Matiz)

        End Set
    End Property

    Public Property NColunas() As Integer
        Get
            Return NCMat
        End Get
        Set(ByVal value As Integer)
            If NColunas <> value Then
                TextBoxNC.Text = value
                TextBoxNC_TextChanged(Nothing, Nothing)
                ReDim Matiz(NLMat + 1, NCMat + 1)
                Grid2Mat(Me.DataGridView1, Matiz)
            End If

        End Set
    End Property

    Public Property Matriz(ByVal Linha As Integer, ByVal Coluna As Integer) As Single
        Get
            Return Matiz(Linha, Coluna)
        End Get
        Set(ByVal value As Single)
            Matiz(Linha, Coluna) = value
        End Set
    End Property

    Private Sub redimGrid(ByVal Linhas As Integer, ByVal colunas As Integer)
        TextBoxNL.Text = Linhas
        TextBoxNC.Text = colunas

        TextBoxNL_Validated(Nothing, Nothing)
    End Sub

    'Copia os valores da dataGrid para a matriz
    Sub Grid2Mat(ByVal MyGrid As System.Windows.Forms.DataGridView, ByRef matriz(,) As Single)
        Dim i, j As Integer

        For i = 1 To MyGrid.Rows.Count
            For j = 1 To MyGrid.Columns.Count
                matriz(i, j) = MyGrid.Item(j - 1, i - 1).Value
            Next
        Next

    End Sub


    'Copia os valores da Matriz para a dataGrid 
    Sub Mat2grid(ByVal matriz(,) As Single, ByRef MyGrid As System.Windows.Forms.DataGridView)
        Dim i, j As Integer


        For i = 1 To MyGrid.Rows.Count
            For j = 1 To MyGrid.Columns.Count
                MyGrid.Item(j - 1, i - 1).Value = matriz(i, j)
            Next
        Next


    End Sub

    Private Sub TextBoxNL_Validated(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxNL.Validated

        DataGridView1.AllowUserToAddRows = True

        If IsNumeric(TextBoxNL.Text) Then
            NLMat = TextBoxNL.Text

            If NCMat = 0 Then
                TextBoxNC.Text = 1
            End If


            Select Case DataGridView1.RowCount
                Case Is > NLMat
                    While DataGridView1.Rows.Count - 1 > NLMat
                        DataGridView1.Rows.RemoveAt(DataGridView1.Rows.Count - 2)
                    End While
                Case Is <= NLMat
                    While DataGridView1.Rows.Count <= NLMat
                        DataGridView1.Rows.Add()
                    End While
            End Select



        End If

        DataGridView1.AllowUserToAddRows = False
    End Sub

    Private Sub TextBoxNC_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNC.TextChanged

        If IsNumeric(TextBoxNC.Text) Then
            NCMat = TextBoxNC.Text

            Select Case DataGridView1.Columns.Count
                Case Is > NCMat
                    While DataGridView1.Columns.Count > NCMat
                        DataGridView1.Columns.RemoveAt(DataGridView1.Columns.Count - 1)
                    End While
                Case Is < NCMat
                    For i = DataGridView1.Columns.Count To NCMat - 1
                        DataGridView1.Columns.Add(i, i + 1)
                    Next
            End Select



        End If

    End Sub




    Private Sub DataGridView1_CellEndEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellEndEdit

        Dim C As Integer = sender.CurrentCellAddress.x
        Dim L As Integer = sender.CurrentCellAddress.Y

        Matiz(L + 1, C + 1) = DataGridView1.Item(C, L).Value

    End Sub

    'Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    '    redimGrid(1, 1)

    'End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim temp As String = ""

        For i = 1 To NLMat
            For j = 1 To NCMat
                temp = temp & vbTab & " | " & Matiz(i, j)
            Next
            temp = temp & vbLf
        Next
        MsgBox(temp)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        DataGridView1.SelectAll()
        For Each celula In DataGridView1.SelectedCells
            celula.value = ""
        Next
        DataGridView1.ClearSelection()


        For i = 1 To NLMat
            For j = 1 To NCMat
                Matiz(i, j) = Nothing
            Next
        Next

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)


    End Sub


    Private Sub OpenToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripButton.Click
        Dim C As Integer
        Dim L As Integer

        Dim openFileDialog1 As New OpenFileDialog()

        'openFileDialog1.InitialDirectory = "c:\"
        openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        openFileDialog1.FilterIndex = 1
        openFileDialog1.RestoreDirectory = True

        If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                Using MyReader As New FileIO.TextFieldParser(openFileDialog1.FileName)
                    MyReader.TextFieldType = FileIO.FieldType.Delimited
                    MyReader.SetDelimiters(",")
                    Dim currentRow As String()
                    Dim currentField As String

                    currentRow = MyReader.ReadFields()
                    NLMat = currentRow.ElementAt(0)
                    NCMat = currentRow.ElementAt(1)
                    redimGrid(NLMat, NCMat)
                    While Not MyReader.EndOfData
                        Try
                            currentRow = MyReader.ReadFields()
                            L = L + 1
                            C = 0

                            For Each currentField In currentRow
                                C = C + 1
                                Matiz(L, C) = currentField

                            Next
                        Catch ex As FileIO.MalformedLineException
                            MsgBox("Line " & ex.Message & _
                            "is not valid and will be skipped.")
                        End Try
                    End While

                    Mat2grid(Matiz, DataGridView1)

                End Using
            Catch Ex As Exception
                ' Let the user know what went wrong.
                Console.WriteLine("The file could not be read:")
                Console.WriteLine(Ex.Message)
            End Try
        End If
    End Sub

    Private Sub SaveToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripButton.Click



        Dim saveFileDialog1 As New SaveFileDialog()

        saveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        saveFileDialog1.FilterIndex = 1
        saveFileDialog1.RestoreDirectory = True

        If saveFileDialog1.ShowDialog() = DialogResult.OK Then
            Dim sb As New StringBuilder()

            sb.AppendLine(NLMat.ToString() & "," & NCMat.ToString)

            Dim temp As String = ""

            For i = 1 To NLMat
                For j = 1 To NCMat - 1
                    temp = temp & vbTab & " , " & Matiz(i, j)
                    sb.Append(Matiz(i, j).ToString() & ",")
                Next
                sb.AppendLine(Matiz(i, NCMat))
                temp = temp & vbLf
            Next
            Using outfile As New StreamWriter(saveFileDialog1.FileName)
                ' outfile.Write(temp)
                outfile.Write(sb.ToString)
            End Using
        End If
    End Sub

    Private Sub NewToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripButton.Click

        DataGridView1.SelectAll()
        For Each celula In DataGridView1.SelectedCells
            celula.value = ""
        Next
        DataGridView1.ClearSelection()


        For i = 1 To NLMat
            For j = 1 To NCMat
                Matiz(i, j) = Nothing
            Next
        Next
    End Sub

    Private Sub HelpToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripButton.Click
        Dim temp As String = ""

        For i = 1 To NLMat
            For j = 1 To NCMat
                temp = temp & vbTab & " | " & Matiz(i, j)
            Next
            temp = temp & vbLf
        Next
        MsgBox(temp)
    End Sub
    Public Sub mm(ByVal matrizIN(,) As Single)
        Matiz = matrizIN
    End Sub

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        redimGrid(1, 1)

    End Sub



End Class
